/*  Project medit
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    medit.apx Application
	t@C:        dtexpand.cpp
	쐬:          Taka2


	Tv
	====
	TDTimeExpand (TDialog) ̃Cve[Vp̃\[Xt@C
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\scrollba.h>
#include <owl\static.h>
#include <owl\inputdia.h>
#include "dtexpand.h"
#include "anim.h"
#include "motion.h"


//
// ̃AvP[Vŏ邷ׂẴbZ[W^R}h
// e[u쐬
//
DEFINE_RESPONSE_TABLE1(TDTimeExpand, TDialog)
//{{TDTimeExpandRSP_TBL_BEGIN}}
	EV_BN_CLICKED(IDOK, CmOK),
	EV_CHILD_NOTIFY_ALL_CODES(IDC_SCROLL_TIME_BEGIN, EvScrollBegin),
	EV_CHILD_NOTIFY_ALL_CODES(IDC_SCROLL_TIME_END,   EvScrollEnd),
	EV_BN_CLICKED(IDC_BUTTON_NEWFRAME, CmNewFrame),
//{{TDTimeExpandRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TDTimeExpand Implementation}}


TDTimeExpand::TDTimeExpand (TWindow* parent, AnimationData *a, Motion *m, TResId resId, TModule* module):
	TDialog(parent, resId, module)
{
	// INSERT>> RXgN^p̃R[h͂

	anim = a;
	motion = m;
	scrollbegin = new TScrollBar(this, IDC_SCROLL_TIME_BEGIN);
	scrollend   = new TScrollBar(this, IDC_SCROLL_TIME_END);
	framebegin  = new TStatic(this, IDC_NUM_TIME_BEGIN);
	frameend    = new TStatic(this, IDC_NUM_TIME_END);
}


TDTimeExpand::~TDTimeExpand ()
{
    Destroy();

    // INSERT>> fXgN^p̃R[h͂

}


void TDTimeExpand::CmOK ()
{
	// INSERT>> ǉR[h͂

   	motion->Zoom(begin, end);
	CloseWindow(IDOK);
}


void TDTimeExpand::SetupWindow ()
{
	TDialog::SetupWindow();

	// INSERT>> ǉ̃R[h͂
	scrollbegin->PageMagnitude = scrollend  ->PageMagnitude = 5;
	scrollbegin->LineMagnitude = scrollend  ->LineMagnitude = 1;

	scrollbegin->SetRange(BEGIN, anim->maxframe);
	scrollend  ->SetRange(BEGIN, anim->maxframe);
	scrollbegin->SetPosition(begin);
	scrollend  ->SetPosition(end);

	begin = motion->beginframe;
	end = motion->endframe;

	char str[10];
	sprintf(str, "%d", begin);
	framebegin->SetText(str);
	sprintf(str, "%d", end);
	frameend->SetText(str);

}

void TDTimeExpand::EvScrollBegin(UINT /*code*/)
{
	if (begin != scrollbegin->GetPosition()) {
		begin = scrollbegin->GetPosition();
		char str[10];
		sprintf(str, "%d", begin);
		framebegin->SetText(str);
		if (begin > scrollend->GetPosition()) {
			end = begin;
			frameend->SetText(str);
			scrollend->SetPosition(begin);
		}
	}
}

void TDTimeExpand::EvScrollEnd(UINT /*code*/)
{
	if (end != scrollend->GetPosition()) {
		end = scrollend->GetPosition();
		char str[10];
		sprintf(str, "%d", end);
		frameend->SetText(str);
		if (scrollbegin->GetPosition() > end) {
			begin = end;
			framebegin->SetText(str);
			scrollbegin->SetPosition(end);
		}
	}
}

void TDTimeExpand::CmNewFrame ()
{
	// INSERT>> ǉR[h͂

	char str[16];
	sprintf(str, "%d", anim->maxframe);
	TInputDialog dialog((TWindow*)anim->Frame, "VKt[ݒ", "őt[ݒ肵Ă", str, 16);
	if (dialog.Execute() == IDOK) {
		int n = atoi(str);
		if (anim->maxframe < n && n < 30000) {
			anim->ExpandFrame(n);

			scrollbegin->SetRange(BEGIN, anim->maxframe);
			scrollend  ->SetRange(BEGIN, anim->maxframe);
			scrollbegin->SetPosition(begin);
			scrollend  ->SetPosition(end);
		}
	}
}


